Index: branches/HTM-14.1-update-dev0/source/Lib/TLibCommon/TComSlice.h
===================================================================
--- branches/HTM-14.1-update-dev0/source/Lib/TLibCommon/TComSlice.h	(revision 1199)
+++ branches/HTM-14.1-update-dev0/source/Lib/TLibCommon/TComSlice.h	(revision 1200)
@@ -1246,5 +1327,5 @@
         std::cout << std::right << std::setw(5) << " "; 
       }
-      
+
       if ( printNumber )
       {
@@ -1253,5 +1334,5 @@
       else
       {
-       std::cout << std::right << std::setw(6) << " ";              
+        std::cout << std::right << std::setw(6) << " ";              
       }
 
@@ -1265,5 +1346,5 @@
   }
 
-  template <typename T> Void xPrintArray( const char* name, Int numElem, T vec, Bool printNumber  )
+  template <typename T> Void xPrintArray( const char* name, Int numElem, T vec, Bool printNumber  )  const
   {
     std::vector<Int> numElemDim2(1, numElem);    
@@ -1273,57 +1354,4 @@
   }
 
-
-  /// VPS EXTENSION 2 SYNTAX ELEMENTS
-
-
-#if H_3D  
-  Int     getDepthId      ( Int layerIdInNuh)                             { return getScalabilityId( getLayerIdInVps(layerIdInNuh), DEPTH_ID ); }
-  Bool    getVpsDepthFlag( Int layerIdInNuh)                              { return (getDepthId( layerIdInNuh ) > 0);  }
-  Int     getLayerIdInNuh( Int viewIndex, Bool depthFlag );   
-
-
-  Void createCamPars(Int iNumViews);
-  Void deleteCamPars();
-  Void initCamParaVPS( Int vOIdxInVps, Int numCp, Bool cpInSliceSegmentHeaderFlag, Int* cpRefVoi, Int** aaiScale, Int** aaiOffset ); 
-  
-
-  Void setCpPrecision( Int  val ) { m_cpPrecision = val; } 
-  Int  getCpPrecision(  ) { return m_cpPrecision; } 
-
-  Void setNumCp( Int i, Int  val ) { m_numCp[i] = val; } 
-  Int  getNumCp( Int i )           { return m_numCp[i]; } 
-
-  Void setCpRefVoi( Int i, Int m, Int  val ) { m_cpRefVoi[i][m] = val; } 
-  Int  getCpRefVoi( Int i, Int m )           { return m_cpRefVoi[i][m]; }   
-  
-  Void setCpInSliceSegmentHeaderFlag( Int i, Bool flag ) { m_cpInSliceSegmentHeaderFlag[i] = flag; } 
-  Bool getCpInSliceSegmentHeaderFlag( Int i )            { return m_cpInSliceSegmentHeaderFlag[i]; } 
-  
-  Void setVpsCpScale( Int i, Int j, Int  val ) { m_aaaiCodedScale [i][0][j] = val; } 
-  Int  getVpsCpScale( Int i, Int j ) { return m_aaaiCodedScale[i][0][j]; } 
-
-  Void setVpsCpOff( Int i, Int j, Int  val ) { m_aaaiCodedOffset[i][0][j] = val; } 
-  Int  getVpsCpOff( Int i, Int j ) { return m_aaaiCodedOffset[i][0][j]; } 
-
-  Void setVpsCpInvScale( Int i, Int j, Int  val ) { m_aaaiCodedScale[i][1][j] = val; } 
-  Int  getVpsCpInvScale( Int i, Int j ) { return m_aaaiCodedScale[i][1][j]; } 
-
-  Void setVpsCpInvOff( Int i, Int j, Int  val ) { m_aaaiCodedOffset[i][1][j] = val; } 
-  Int  getVpsCpInvOff( Int i, Int j ) { return m_aaaiCodedOffset[i][1][j]; } 
-
-// Derived
-  Void deriveCpPresentFlag( );
-
-  Void setCpPresentFlag( Int i, Int m, Bool flag ) { m_cpPresentFlag[i][m] = flag; } 
-  Bool getCpPresentFlag( Int i, Int m )           { return m_cpPresentFlag[i][m]; }   
-
-
-
-  Int* getCodedScale         ( Int viewIndex )  { return m_aaaiCodedScale [viewIndex][0]; }
-  Int* getCodedOffset        ( Int viewIndex )  { return m_aaaiCodedOffset[viewIndex][0]; }
-  Int* getInvCodedScale      ( Int viewIndex )  { return m_aaaiCodedScale [viewIndex][1]; }
-  Int* getInvCodedOffset     ( Int viewIndex )  { return m_aaaiCodedOffset[viewIndex][1]; }
-
-#endif
 #endif
 };
@@ -1373,50 +1401,50 @@
 #endif
 
+
 class Window
 {
 private:
-  Bool          m_enabledFlag;
-  Int           m_winLeftOffset;
-  Int           m_winRightOffset;
-  Int           m_winTopOffset;
-  Int           m_winBottomOffset;
-#if H_MV
+  Bool m_enabledFlag;
+  Int  m_winLeftOffset;
+  Int  m_winRightOffset;
+  Int  m_winTopOffset;
+  Int  m_winBottomOffset;
+#if NH_MV
   Bool          m_scaledFlag; 
 #endif
 public:
   Window()
-  : m_enabledFlag (false)
-  , m_winLeftOffset     (0)
-  , m_winRightOffset    (0)
-  , m_winTopOffset      (0)
-  , m_winBottomOffset   (0)
-#if H_MV
+  : m_enabledFlag    (false)
+  , m_winLeftOffset  (0)
+  , m_winRightOffset (0)
+  , m_winTopOffset   (0)
+  , m_winBottomOffset(0)
+#if NH_MV
   , m_scaledFlag(true)
 #endif
   { }
 
-  Bool          getWindowEnabledFlag() const      { return m_enabledFlag; }
-  Void          resetWindow()                     { m_enabledFlag = false; m_winLeftOffset = m_winRightOffset = m_winTopOffset = m_winBottomOffset = 0; }
-  Int           getWindowLeftOffset() const       { return m_enabledFlag ? m_winLeftOffset : 0; }
-  Void          setWindowLeftOffset(Int val)      { m_winLeftOffset = val; m_enabledFlag = true; }
-  Int           getWindowRightOffset() const      { return m_enabledFlag ? m_winRightOffset : 0; }
-  Void          setWindowRightOffset(Int val)     { m_winRightOffset = val; m_enabledFlag = true; }
-  Int           getWindowTopOffset() const        { return m_enabledFlag ? m_winTopOffset : 0; }
-  Void          setWindowTopOffset(Int val)       { m_winTopOffset = val; m_enabledFlag = true; }
-  Int           getWindowBottomOffset() const     { return m_enabledFlag ? m_winBottomOffset: 0; }
-  Void          setWindowBottomOffset(Int val)    { m_winBottomOffset = val; m_enabledFlag = true; }
-
-#if H_MV
+  Bool getWindowEnabledFlag() const   { return m_enabledFlag;                          }
+  Int  getWindowLeftOffset() const    { return m_enabledFlag ? m_winLeftOffset : 0;    }
+  Void setWindowLeftOffset(Int val)   { m_winLeftOffset = val; m_enabledFlag = true;   }
+  Int  getWindowRightOffset() const   { return m_enabledFlag ? m_winRightOffset : 0;   }
+  Void setWindowRightOffset(Int val)  { m_winRightOffset = val; m_enabledFlag = true;  }
+  Int  getWindowTopOffset() const     { return m_enabledFlag ? m_winTopOffset : 0;     }
+  Void setWindowTopOffset(Int val)    { m_winTopOffset = val; m_enabledFlag = true;    }
+  Int  getWindowBottomOffset() const  { return m_enabledFlag ? m_winBottomOffset: 0;   }
+  Void setWindowBottomOffset(Int val) { m_winBottomOffset = val; m_enabledFlag = true; }
+
+#if NH_MV
   Void          setScaledFlag(Bool flag)          { m_scaledFlag = flag;  } 
   Bool          getScaledFlag() const             { return m_scaledFlag;  } 
   Void          scaleOffsets( Int scal );
 #endif
-  Void          setWindow(Int offsetLeft, Int offsetLRight, Int offsetLTop, Int offsetLBottom)
+  Void setWindow(Int offsetLeft, Int offsetLRight, Int offsetLTop, Int offsetLBottom)
   {
-    m_enabledFlag       = true;
-    m_winLeftOffset     = offsetLeft;
-    m_winRightOffset    = offsetLRight;
-    m_winTopOffset      = offsetLTop;
-    m_winBottomOffset   = offsetLBottom;
+    m_enabledFlag     = true;
+    m_winLeftOffset   = offsetLeft;
+    m_winRightOffset  = offsetLRight;
+    m_winTopOffset    = offsetLTop;
+    m_winBottomOffset = offsetLBottom;
   }
 };
@@ -1426,170 +1454,230 @@
 {
 private:
-  Bool m_aspectRatioInfoPresentFlag;
-  Int  m_aspectRatioIdc;
-  Int  m_sarWidth;
-  Int  m_sarHeight;
-  Bool m_overscanInfoPresentFlag;
-  Bool m_overscanAppropriateFlag;
-  Bool m_videoSignalTypePresentFlag;
-  Int  m_videoFormat;
-  Bool m_videoFullRangeFlag;
-  Bool m_colourDescriptionPresentFlag;
-  Int  m_colourPrimaries;
-  Int  m_transferCharacteristics;
-  Int  m_matrixCoefficients;
-  Bool m_chromaLocInfoPresentFlag;
-  Int  m_chromaSampleLocTypeTopField;
-  Int  m_chromaSampleLocTypeBottomField;
-  Bool m_neutralChromaIndicationFlag;
-  Bool m_fieldSeqFlag;
-
-  Window m_defaultDisplayWindow;
-  Bool m_frameFieldInfoPresentFlag;
-  Bool m_hrdParametersPresentFlag;
-  Bool m_bitstreamRestrictionFlag;
-  Bool m_tilesFixedStructureFlag;
-  Bool m_motionVectorsOverPicBoundariesFlag;
-  Bool m_restrictedRefPicListsFlag;
-  Int  m_minSpatialSegmentationIdc;
-  Int  m_maxBytesPerPicDenom;
-  Int  m_maxBitsPerMinCuDenom;
-  Int  m_log2MaxMvLengthHorizontal;
-  Int  m_log2MaxMvLengthVertical;
-  TComHRD m_hrdParameters;
+  Bool       m_aspectRatioInfoPresentFlag;
+  Int        m_aspectRatioIdc;
+  Int        m_sarWidth;
+  Int        m_sarHeight;
+  Bool       m_overscanInfoPresentFlag;
+  Bool       m_overscanAppropriateFlag;
+  Bool       m_videoSignalTypePresentFlag;
+  Int        m_videoFormat;
+  Bool       m_videoFullRangeFlag;
+  Bool       m_colourDescriptionPresentFlag;
+  Int        m_colourPrimaries;
+  Int        m_transferCharacteristics;
+  Int        m_matrixCoefficients;
+  Bool       m_chromaLocInfoPresentFlag;
+  Int        m_chromaSampleLocTypeTopField;
+  Int        m_chromaSampleLocTypeBottomField;
+  Bool       m_neutralChromaIndicationFlag;
+  Bool       m_fieldSeqFlag;
+  Window     m_defaultDisplayWindow;
+  Bool       m_frameFieldInfoPresentFlag;
+  Bool       m_hrdParametersPresentFlag;
+  Bool       m_bitstreamRestrictionFlag;
+  Bool       m_tilesFixedStructureFlag;
+  Bool       m_motionVectorsOverPicBoundariesFlag;
+  Bool       m_restrictedRefPicListsFlag;
+  Int        m_minSpatialSegmentationIdc;
+  Int        m_maxBytesPerPicDenom;
+  Int        m_maxBitsPerMinCuDenom;
+  Int        m_log2MaxMvLengthHorizontal;
+  Int        m_log2MaxMvLengthVertical;
+  TComHRD    m_hrdParameters;
   TimingInfo m_timingInfo;
 
 public:
   TComVUI()
-    :m_aspectRatioInfoPresentFlag(false)
-    ,m_aspectRatioIdc(0)
-    ,m_sarWidth(0)
-    ,m_sarHeight(0)
-    ,m_overscanInfoPresentFlag(false)
-    ,m_overscanAppropriateFlag(false)
-    ,m_videoSignalTypePresentFlag(false)
-    ,m_videoFormat(5)
-    ,m_videoFullRangeFlag(false)
-    ,m_colourDescriptionPresentFlag(false)
-    ,m_colourPrimaries(2)
-    ,m_transferCharacteristics(2)
-    ,m_matrixCoefficients(2)
-    ,m_chromaLocInfoPresentFlag(false)
-    ,m_chromaSampleLocTypeTopField(0)
-    ,m_chromaSampleLocTypeBottomField(0)
-    ,m_neutralChromaIndicationFlag(false)
-    ,m_fieldSeqFlag(false)
-    ,m_frameFieldInfoPresentFlag(false)
-    ,m_hrdParametersPresentFlag(false)
-    ,m_bitstreamRestrictionFlag(false)
-    ,m_tilesFixedStructureFlag(false)
-    ,m_motionVectorsOverPicBoundariesFlag(true)
-    ,m_restrictedRefPicListsFlag(1)
-    ,m_minSpatialSegmentationIdc(0)
-    ,m_maxBytesPerPicDenom(2)
-    ,m_maxBitsPerMinCuDenom(1)
-    ,m_log2MaxMvLengthHorizontal(15)
-    ,m_log2MaxMvLengthVertical(15)
+    : m_aspectRatioInfoPresentFlag        (false) //TODO: This initialiser list contains magic numbers
+    , m_aspectRatioIdc                    (0)
+    , m_sarWidth                          (0)
+    , m_sarHeight                         (0)
+    , m_overscanInfoPresentFlag           (false)
+    , m_overscanAppropriateFlag           (false)
+    , m_videoSignalTypePresentFlag        (false)
+    , m_videoFormat                       (5)
+    , m_videoFullRangeFlag                (false)
+    , m_colourDescriptionPresentFlag      (false)
+    , m_colourPrimaries                   (2)
+    , m_transferCharacteristics           (2)
+    , m_matrixCoefficients                (2)
+    , m_chromaLocInfoPresentFlag          (false)
+    , m_chromaSampleLocTypeTopField       (0)
+    , m_chromaSampleLocTypeBottomField    (0)
+    , m_neutralChromaIndicationFlag       (false)
+    , m_fieldSeqFlag                      (false)
+    , m_frameFieldInfoPresentFlag         (false)
+    , m_hrdParametersPresentFlag          (false)
+    , m_bitstreamRestrictionFlag          (false)
+    , m_tilesFixedStructureFlag           (false)
+    , m_motionVectorsOverPicBoundariesFlag(true)
+    , m_restrictedRefPicListsFlag         (1)
+    , m_minSpatialSegmentationIdc         (0)
+    , m_maxBytesPerPicDenom               (2)
+    , m_maxBitsPerMinCuDenom              (1)
+    , m_log2MaxMvLengthHorizontal         (15)
+    , m_log2MaxMvLengthVertical           (15)
   {}
 
-  virtual ~TComVUI() {}
-
-  Bool getAspectRatioInfoPresentFlag() { return m_aspectRatioInfoPresentFlag; }
-  Void setAspectRatioInfoPresentFlag(Bool i) { m_aspectRatioInfoPresentFlag = i; }
-
-  Int getAspectRatioIdc() { return m_aspectRatioIdc; }
-  Void setAspectRatioIdc(Int i) { m_aspectRatioIdc = i; }
-
-  Int getSarWidth() { return m_sarWidth; }
-  Void setSarWidth(Int i) { m_sarWidth = i; }
-
-  Int getSarHeight() { return m_sarHeight; }
-  Void setSarHeight(Int i) { m_sarHeight = i; }
-
-  Bool getOverscanInfoPresentFlag() { return m_overscanInfoPresentFlag; }
-  Void setOverscanInfoPresentFlag(Bool i) { m_overscanInfoPresentFlag = i; }
-
-  Bool getOverscanAppropriateFlag() { return m_overscanAppropriateFlag; }
-  Void setOverscanAppropriateFlag(Bool i) { m_overscanAppropriateFlag = i; }
-
-  Bool getVideoSignalTypePresentFlag() { return m_videoSignalTypePresentFlag; }
-  Void setVideoSignalTypePresentFlag(Bool i) { m_videoSignalTypePresentFlag = i; }
-
-  Int getVideoFormat() { return m_videoFormat; }
-  Void setVideoFormat(Int i) { m_videoFormat = i; }
-
-  Bool getVideoFullRangeFlag() { return m_videoFullRangeFlag; }
-  Void setVideoFullRangeFlag(Bool i) { m_videoFullRangeFlag = i; }
-
-  Bool getColourDescriptionPresentFlag() { return m_colourDescriptionPresentFlag; }
-  Void setColourDescriptionPresentFlag(Bool i) { m_colourDescriptionPresentFlag = i; }
-
-  Int getColourPrimaries() { return m_colourPrimaries; }
-  Void setColourPrimaries(Int i) { m_colourPrimaries = i; }
-
-  Int getTransferCharacteristics() { return m_transferCharacteristics; }
-  Void setTransferCharacteristics(Int i) { m_transferCharacteristics = i; }
-
-  Int getMatrixCoefficients() { return m_matrixCoefficients; }
-  Void setMatrixCoefficients(Int i) { m_matrixCoefficients = i; }
-
-  Bool getChromaLocInfoPresentFlag() { return m_chromaLocInfoPresentFlag; }
-  Void setChromaLocInfoPresentFlag(Bool i) { m_chromaLocInfoPresentFlag = i; }
-
-  Int getChromaSampleLocTypeTopField() { return m_chromaSampleLocTypeTopField; }
-  Void setChromaSampleLocTypeTopField(Int i) { m_chromaSampleLocTypeTopField = i; }
-
-  Int getChromaSampleLocTypeBottomField() { return m_chromaSampleLocTypeBottomField; }
-  Void setChromaSampleLocTypeBottomField(Int i) { m_chromaSampleLocTypeBottomField = i; }
-
-  Bool getNeutralChromaIndicationFlag() { return m_neutralChromaIndicationFlag; }
-  Void setNeutralChromaIndicationFlag(Bool i) { m_neutralChromaIndicationFlag = i; }
-
-  Bool getFieldSeqFlag() { return m_fieldSeqFlag; }
-  Void setFieldSeqFlag(Bool i) { m_fieldSeqFlag = i; }
-
-  Bool getFrameFieldInfoPresentFlag() { return m_frameFieldInfoPresentFlag; }
-  Void setFrameFieldInfoPresentFlag(Bool i) { m_frameFieldInfoPresentFlag = i; }
-
-  Window& getDefaultDisplayWindow()                              { return m_defaultDisplayWindow;                }
-  Void    setDefaultDisplayWindow(Window& defaultDisplayWindow ) { m_defaultDisplayWindow = defaultDisplayWindow; }
-
-  Bool getHrdParametersPresentFlag() { return m_hrdParametersPresentFlag; }
-  Void setHrdParametersPresentFlag(Bool i) { m_hrdParametersPresentFlag = i; }
-
-  Bool getBitstreamRestrictionFlag() { return m_bitstreamRestrictionFlag; }
-  Void setBitstreamRestrictionFlag(Bool i) { m_bitstreamRestrictionFlag = i; }
-
-  Bool getTilesFixedStructureFlag() { return m_tilesFixedStructureFlag; }
-  Void setTilesFixedStructureFlag(Bool i) { m_tilesFixedStructureFlag = i; }
-
-  Bool getMotionVectorsOverPicBoundariesFlag() { return m_motionVectorsOverPicBoundariesFlag; }
-  Void setMotionVectorsOverPicBoundariesFlag(Bool i) { m_motionVectorsOverPicBoundariesFlag = i; }
-
-  Bool getRestrictedRefPicListsFlag() { return m_restrictedRefPicListsFlag; }
-  Void setRestrictedRefPicListsFlag(Bool b) { m_restrictedRefPicListsFlag = b; }
-
-  Int getMinSpatialSegmentationIdc() { return m_minSpatialSegmentationIdc; }
-  Void setMinSpatialSegmentationIdc(Int i) { m_minSpatialSegmentationIdc = i; }
-  Int getMaxBytesPerPicDenom() { return m_maxBytesPerPicDenom; }
-  Void setMaxBytesPerPicDenom(Int i) { m_maxBytesPerPicDenom = i; }
-
-  Int getMaxBitsPerMinCuDenom() { return m_maxBitsPerMinCuDenom; }
-  Void setMaxBitsPerMinCuDenom(Int i) { m_maxBitsPerMinCuDenom = i; }
-
-  Int getLog2MaxMvLengthHorizontal() { return m_log2MaxMvLengthHorizontal; }
-  Void setLog2MaxMvLengthHorizontal(Int i) { m_log2MaxMvLengthHorizontal = i; }
-
-  Int getLog2MaxMvLengthVertical() { return m_log2MaxMvLengthVertical; }
-  Void setLog2MaxMvLengthVertical(Int i) { m_log2MaxMvLengthVertical = i; }
-
-  TComHRD* getHrdParameters                 ()             { return &m_hrdParameters; }
-  TimingInfo* getTimingInfo() { return &m_timingInfo; }
-#if H_MV
-  Void inferVideoSignalInfo( TComVPS* vps, Int layerIdCurr );
+  virtual           ~TComVUI() {}
+
+  Bool              getAspectRatioInfoPresentFlag() const                  { return m_aspectRatioInfoPresentFlag;           }
+  Void              setAspectRatioInfoPresentFlag(Bool i)                  { m_aspectRatioInfoPresentFlag = i;              }
+
+  Int               getAspectRatioIdc() const                              { return m_aspectRatioIdc;                       }
+  Void              setAspectRatioIdc(Int i)                               { m_aspectRatioIdc = i;                          }
+
+  Int               getSarWidth() const                                    { return m_sarWidth;                             }
+  Void              setSarWidth(Int i)                                     { m_sarWidth = i;                                }
+
+  Int               getSarHeight() const                                   { return m_sarHeight;                            }
+  Void              setSarHeight(Int i)                                    { m_sarHeight = i;                               }
+
+  Bool              getOverscanInfoPresentFlag() const                     { return m_overscanInfoPresentFlag;              }
+  Void              setOverscanInfoPresentFlag(Bool i)                     { m_overscanInfoPresentFlag = i;                 }
+
+  Bool              getOverscanAppropriateFlag() const                     { return m_overscanAppropriateFlag;              }
+  Void              setOverscanAppropriateFlag(Bool i)                     { m_overscanAppropriateFlag = i;                 }
+
+  Bool              getVideoSignalTypePresentFlag() const                  { return m_videoSignalTypePresentFlag;           }
+  Void              setVideoSignalTypePresentFlag(Bool i)                  { m_videoSignalTypePresentFlag = i;              }
+
+  Int               getVideoFormat() const                                 { return m_videoFormat;                          }
+  Void              setVideoFormat(Int i)                                  { m_videoFormat = i;                             }
+
+  Bool              getVideoFullRangeFlag() const                          { return m_videoFullRangeFlag;                   }
+  Void              setVideoFullRangeFlag(Bool i)                          { m_videoFullRangeFlag = i;                      }
+
+  Bool              getColourDescriptionPresentFlag() const                { return m_colourDescriptionPresentFlag;         }
+  Void              setColourDescriptionPresentFlag(Bool i)                { m_colourDescriptionPresentFlag = i;            }
+
+  Int               getColourPrimaries() const                             { return m_colourPrimaries;                      }
+  Void              setColourPrimaries(Int i)                              { m_colourPrimaries = i;                         }
+
+  Int               getTransferCharacteristics() const                     { return m_transferCharacteristics;              }
+  Void              setTransferCharacteristics(Int i)                      { m_transferCharacteristics = i;                 }
+
+  Int               getMatrixCoefficients() const                          { return m_matrixCoefficients;                   }
+  Void              setMatrixCoefficients(Int i)                           { m_matrixCoefficients = i;                      }
+
+  Bool              getChromaLocInfoPresentFlag() const                    { return m_chromaLocInfoPresentFlag;             }
+  Void              setChromaLocInfoPresentFlag(Bool i)                    { m_chromaLocInfoPresentFlag = i;                }
+
+  Int               getChromaSampleLocTypeTopField() const                 { return m_chromaSampleLocTypeTopField;          }
+  Void              setChromaSampleLocTypeTopField(Int i)                  { m_chromaSampleLocTypeTopField = i;             }
+
+  Int               getChromaSampleLocTypeBottomField() const              { return m_chromaSampleLocTypeBottomField;       }
+  Void              setChromaSampleLocTypeBottomField(Int i)               { m_chromaSampleLocTypeBottomField = i;          }
+
+  Bool              getNeutralChromaIndicationFlag() const                 { return m_neutralChromaIndicationFlag;          }
+  Void              setNeutralChromaIndicationFlag(Bool i)                 { m_neutralChromaIndicationFlag = i;             }
+
+  Bool              getFieldSeqFlag() const                                { return m_fieldSeqFlag;                         }
+  Void              setFieldSeqFlag(Bool i)                                { m_fieldSeqFlag = i;                            }
+
+  Bool              getFrameFieldInfoPresentFlag() const                   { return m_frameFieldInfoPresentFlag;            }
+  Void              setFrameFieldInfoPresentFlag(Bool i)                   { m_frameFieldInfoPresentFlag = i;               }
+
+  Window&           getDefaultDisplayWindow()                              { return m_defaultDisplayWindow;                 }
+  const Window&     getDefaultDisplayWindow() const                        { return m_defaultDisplayWindow;                 }
+  Void              setDefaultDisplayWindow(Window& defaultDisplayWindow ) { m_defaultDisplayWindow = defaultDisplayWindow; }
+
+  Bool              getHrdParametersPresentFlag() const                    { return m_hrdParametersPresentFlag;             }
+  Void              setHrdParametersPresentFlag(Bool i)                    { m_hrdParametersPresentFlag = i;                }
+
+  Bool              getBitstreamRestrictionFlag() const                    { return m_bitstreamRestrictionFlag;             }
+  Void              setBitstreamRestrictionFlag(Bool i)                    { m_bitstreamRestrictionFlag = i;                }
+
+  Bool              getTilesFixedStructureFlag() const                     { return m_tilesFixedStructureFlag;              }
+  Void              setTilesFixedStructureFlag(Bool i)                     { m_tilesFixedStructureFlag = i;                 }
+
+  Bool              getMotionVectorsOverPicBoundariesFlag() const          { return m_motionVectorsOverPicBoundariesFlag;   }
+  Void              setMotionVectorsOverPicBoundariesFlag(Bool i)          { m_motionVectorsOverPicBoundariesFlag = i;      }
+
+  Bool              getRestrictedRefPicListsFlag() const                   { return m_restrictedRefPicListsFlag;            }
+  Void              setRestrictedRefPicListsFlag(Bool b)                   { m_restrictedRefPicListsFlag = b;               }
+
+  Int               getMinSpatialSegmentationIdc() const                   { return m_minSpatialSegmentationIdc;            }
+  Void              setMinSpatialSegmentationIdc(Int i)                    { m_minSpatialSegmentationIdc = i;               }
+
+  Int               getMaxBytesPerPicDenom() const                         { return m_maxBytesPerPicDenom;                  }
+  Void              setMaxBytesPerPicDenom(Int i)                          { m_maxBytesPerPicDenom = i;                     }
+
+  Int               getMaxBitsPerMinCuDenom() const                        { return m_maxBitsPerMinCuDenom;                 }
+  Void              setMaxBitsPerMinCuDenom(Int i)                         { m_maxBitsPerMinCuDenom = i;                    }
+
+  Int               getLog2MaxMvLengthHorizontal() const                   { return m_log2MaxMvLengthHorizontal;            }
+  Void              setLog2MaxMvLengthHorizontal(Int i)                    { m_log2MaxMvLengthHorizontal = i;               }
+
+  Int               getLog2MaxMvLengthVertical() const                     { return m_log2MaxMvLengthVertical;              }
+  Void              setLog2MaxMvLengthVertical(Int i)                      { m_log2MaxMvLengthVertical = i;                 }
+
+  TComHRD*          getHrdParameters()                                     { return &m_hrdParameters;                       }
+  const TComHRD*    getHrdParameters()  const                              { return &m_hrdParameters;                       }
+
+  TimingInfo*       getTimingInfo()                                        { return &m_timingInfo;                          }
+  const TimingInfo* getTimingInfo() const                                  { return &m_timingInfo;                          }
+#if NH_MV
+  Void              inferVideoSignalInfo( const TComVPS* vps, Int layerIdCurr );
 #endif
 };
 
-#if H_3D
+/// SPS RExt class
+class TComSPSRExt // Names aligned to text specification
+{
+private:
+  Bool             m_transformSkipRotationEnabledFlag;
+  Bool             m_transformSkipContextEnabledFlag;
+  Bool             m_rdpcmEnabledFlag[NUMBER_OF_RDPCM_SIGNALLING_MODES];
+  Bool             m_extendedPrecisionProcessingFlag;
+  Bool             m_intraSmoothingDisabledFlag;
+  Bool             m_highPrecisionOffsetsEnabledFlag;
+  Bool             m_persistentRiceAdaptationEnabledFlag;
+  Bool             m_cabacBypassAlignmentEnabledFlag;
+
+public:
+  TComSPSRExt();
+
+  Bool settingsDifferFromDefaults() const
+  {
+    return getTransformSkipRotationEnabledFlag()
+        || getTransformSkipContextEnabledFlag()
+        || getRdpcmEnabledFlag(RDPCM_SIGNAL_IMPLICIT)
+        || getRdpcmEnabledFlag(RDPCM_SIGNAL_EXPLICIT)
+        || getExtendedPrecisionProcessingFlag()
+        || getIntraSmoothingDisabledFlag()
+        || getHighPrecisionOffsetsEnabledFlag()
+        || getPersistentRiceAdaptationEnabledFlag()
+        || getCabacBypassAlignmentEnabledFlag();
+  }
+
+
+  Bool getTransformSkipRotationEnabledFlag() const                                     { return m_transformSkipRotationEnabledFlag;     }
+  Void setTransformSkipRotationEnabledFlag(const Bool value)                           { m_transformSkipRotationEnabledFlag = value;    }
+
+  Bool getTransformSkipContextEnabledFlag() const                                      { return m_transformSkipContextEnabledFlag;      }
+  Void setTransformSkipContextEnabledFlag(const Bool value)                            { m_transformSkipContextEnabledFlag = value;     }
+
+  Bool getRdpcmEnabledFlag(const RDPCMSignallingMode signallingMode) const             { return m_rdpcmEnabledFlag[signallingMode];     }
+  Void setRdpcmEnabledFlag(const RDPCMSignallingMode signallingMode, const Bool value) { m_rdpcmEnabledFlag[signallingMode] = value;    }
+
+  Bool getExtendedPrecisionProcessingFlag() const                                      { return m_extendedPrecisionProcessingFlag;      }
+  Void setExtendedPrecisionProcessingFlag(Bool value)                                  { m_extendedPrecisionProcessingFlag = value;     }
+
+  Bool getIntraSmoothingDisabledFlag() const                                           { return m_intraSmoothingDisabledFlag;           }
+  Void setIntraSmoothingDisabledFlag(Bool bValue)                                      { m_intraSmoothingDisabledFlag=bValue;           }
+
+  Bool getHighPrecisionOffsetsEnabledFlag() const                                      { return m_highPrecisionOffsetsEnabledFlag;      }
+  Void setHighPrecisionOffsetsEnabledFlag(Bool value)                                  { m_highPrecisionOffsetsEnabledFlag = value;     }
+
+  Bool getPersistentRiceAdaptationEnabledFlag() const                                  { return m_persistentRiceAdaptationEnabledFlag;  }
+  Void setPersistentRiceAdaptationEnabledFlag(const Bool value)                        { m_persistentRiceAdaptationEnabledFlag = value; }
+
+  Bool getCabacBypassAlignmentEnabledFlag() const                                      { return m_cabacBypassAlignmentEnabledFlag;      }
+  Void setCabacBypassAlignmentEnabledFlag(const Bool value)                            { m_cabacBypassAlignmentEnabledFlag = value;     }
+};
+
+
+#if NH_3D
 class TComSps3dExtension
 {
